<?
/*      
        NOTE THAT YOU HAVE NO RIGHTS TO MODIFY THE SOURCE CODE!
        READ THE LICENSE AND THE MANUAL FOR MORE INFORMATIONS.

        */



/**********************************************************************
	declaration of functions 
**********************************************************************/

//function to create logfiles
function CreateNewEmptyFile ($FileToCheck)
{
	
	//Create file with 0 bytes
	if(@!fopen ($FileToCheck, "w") OR @!chmod ($FileToCheck, 0666))
	{
		//failure text
		
		//get the user of the running php script
		$CurrentUser 	= @get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
But the user <i>$CurrentUser</i> have no rights to write the file <i>$FileToCheck</i> to your system.</br><br>
You must set the filepermissions to writeable that 
phpMySearch is able to write this file.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}

//control if a file is readable
function FileIsReadable ($FileToCheck)
{
	
	if(@!fopen ($FileToCheck, "r"))
	{
		
		//get the file owner
		$FileOwner 	= @fileowner ($FileToCheck);
		if (!$FileOwner){ $FileOwner = "unknown"; }
		
		//get the user of the running php script
		$CurrentUser 	= get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
The owner of the file <i>$FileToCheck</i> is <i>$FileOwner</i>.</br>
The user <i>$CurrentUser</i> have no rights to read the file <i>$FileToCheck</i> or the file does not exists on your system.</br><br>
You must set the filepermissions of <i>$FileToCheck</i> to readable.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}

//control if a directory is readable
function DirIsReadable ($DirToCheck)
{
	
	if(@!is_readable($DirToCheck))
	{
		
		//get the file owner
		$FileOwner 	= @fileowner ($DirToCheck);
		if (!$FileOwner){ $FileOwner = "unknown"; }
		
		//get the user of the running php script
		$CurrentUser 	= get_current_user ();
		if (!$CurrentUser){ $CurrentUser = "unknown"; }
		
		$Out =<<<END
phpMySearch is running under your system as the user <i>$CurrentUser</i>.</br>
The owner of the directory <i>$DirToCheck</i> is <i>$FileOwner</i>.</br>
The user <i>$CurrentUser</i> have no rights to read the directory <i>$DirToCheck</i> or the directory does not exists on your system.</br><br>
You must set the filepermissions of <i>$DirToCheck</i> to readable.<br>
You can do this e.g. under UNIX-systems with:</br>
<i>CHMOD 666</i> or <i>CHMOD UGO+RW</i></br>
You can do this e.g. with your FTP client.<br><br>
<b>Installation aborted!</b><br>
END;
		
		echo $Out;
		exit();
		
	}

}



/**********************************************************************
	define variables
**********************************************************************/

//set directory path
$a = explode ("install.php", $HTTP_SERVER_VARS["PATH_TRANSLATED"]);
$Path = $a[0];

//set DataBaseSettings file name
$DataBaseSettings = $Path."Src/DataBaseSettings.inc.php";



/**********************************************************************
	aborts the installation if DataBaseSettings exists
**********************************************************************/

//check for DataBaseSettings
if (is_readable ($DataBaseSettings)){
	echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<font color="red"><b>ERROR</b></font>
		<p>If you want to reinstall phpMySearch you must delete the file:</p>
		<p><i>$DataBaseSettings</i></p>
		<p>manually e.g. with your FTP-Client.</p>
		<p>After that you are able to execute this installation again.</p>
		<p></p>
		<b>Installation aborted!</b><br>
	</body>

</html>
AUSGABE;

exit();

}



/**********************************************************************
	Aborts the installation
**********************************************************************/

//abort installation
if ($HTTP_POST_VARS["Step"]=="Abort"){
	header ("Location: http://phpMySearch.web4.hm");
	exit();
	
}

//not agree to license
if ($HTTP_POST_VARS["agree"]=="no"){
	header ("Location: http://phpMySearch.web4.hm");
	exit();

}



/**********************************************************************
	the license
**********************************************************************/

//output the license to browser
if ($HTTP_POST_VARS["Step"]=="Next"){
	
	echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<form name="FormName" action="install.php" method="POST">
			<b><font size="4">Terms Of Usage<br>
				</font></b>
  <p>---------------------------------------------------------------------<br>
    The phpMySearch License, version 5.0<br>
    Copyright (c) 2001 - 2002 The phpMySearch Group. All rights reserved.<br>
    ---------------------------------------------------------------------</p>
  <p>Redistribution and use in source and binary forms, with or without<br>
    modification, is permitted provided that the following conditions<br>
    are met:</p>
  <p>1. You may use this software and documentation for free, privately as well 
    as commercially,<br>
    free of charge and without restrictions, so long this license and the copyright 
    notice,<br>
    in the software and documentation and at the end of the search output is preserved.<br>
    <br>
    2. You are allowed to modify the sourcecode, when you mail us the changed 
    sourcecode<br>
    to phpMySearch@web4.hm<br>
    <br>
    3. The name &quot;phpMySearch&quot; must not be used to endorse or promote 
    products<br>
    derived from this software without prior permission from the<br>
    phpMySearch Group. This does not apply to add-on libraries or tools<br>
    that work in conjunction with phpMySearch.<br>
    <br>
    4. The phpMySearch Group may publish revised and/or new versions of the<br>
    license from time to time. Each version will be given a distinguishing version 
    number.<br>
    Once covered code has been published under a particular version of the license,<br>
    you may always continue to use it under the terms of that version.<br>
    You may also choose to use such covered code under the terms of any subsequent 
    version of the license<br>
    published by the phpMySearch Group.<br>
    No one other than the phpMySearch Group has the right to modify the terms<br>
    applicable to covered code created under this License.<br>
    <br>
    5. This product is not free for reselling - reselling free code parts<br>
    from phpMySearch needs a special product-registration from the phpMySearch 
    Group.<br>
    <br>
    6. The phpMySearch Group is allowed to forbid the usage of this program or 
    code-parts.<br>
    <br>
    7. THIS SOFTWARE IS PROVIDED BY THE PHPMYSEARCH DEVELOPMENT TEAM 'AS IS' AND<br>
    ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,<br>
    THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A<br>
    PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE PHPMYSEARCH<br>
    DEVELOPMENT TEAM OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT,<br>
    INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES<br>
    (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR<br>
    SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)<br>
    HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,<br>
    STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)<br>
    ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED<br>
    OF THE POSSIBILITY OF SUCH DAMAGE.</p>
  <p>--------------------------------------------------------------------</p>
  <p>For more information on the phpMySearch Group and the phpMySearch project,<br>
    please see <a href="http://phpMySearch.web4.hm" target="_blank">http://phpMySearch.web4.hm</a>.<br>
    <br>
    phpMySearch is a project from:<br>
    Webagentur web4.hm<br>
    Pyrmonter Strasse 42<br>
    D-31789 Hameln, Germany.<br>
    Tel: +49-5151-609970-0<br>
    <a href="http://www.web4.hm" target="_blank">http://www.web4.hm</a><br>
    <a href="mailto:phpMySearch@web4.hm">phpMySearch@web4.hm</a><br>
  </p>
	<br>
			<p><input type="radio" value="yes" name="agree">I agree to this terms<br>
				<input type="radio" value="no" name="agree" checked>I do not agree to this terms</p>
			<div align="left"><input type="hidden" value="2" name="Step">
				<p><input type="submit" name="submitButtonName" value="Next"></p>
			</div>
		</form>
	</body>

</html>

AUSGABE;

exit();

}	


/**********************************************************************
	1st site
**********************************************************************/

//output the 1st page to browser
if (!$HTTP_POST_VARS["Step"]){
echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<form name="FormName" action="install.php" method="POST">
			<div align="center">
				<b>This is the installationsscript for phpMySearch</b>
				<p>click on next to install phpMySearch </p>
				<p><input type="submit" name="Step" value="Abort"><input type="submit" name="Step" value="Next"></p>
			</div>
		</form>
	</body>

</html>
AUSGABE;

exit();

}



/**********************************************************************
	2nd site
**********************************************************************/

//check for system requirements
if ($HTTP_POST_VARS["agree"]=="yes" AND $HTTP_POST_VARS["Step"]=="2"){
	
	//check phpversion
	if (phpversion() < "4.0.2"){
		$InstallationsError = True;
		$Error .= "You system must have PHP 4.0.2 minimum! -> Please upgrade your PHP-version.<br>";
	}
	
	//check curl
	if (extension_loaded ("curl") != "1"){
		$InstallationsError = True;
		$Error .= "On your system must have Curl compiled in PHP! -> Please check www.php.net how you can do this.<br>";				
	}

	//check call time
	if (ini_get ("allow_call_time_pass_reference") != True){
		$InstallationsError = True;
		$Error .= "Set in your php.ini <i>allow_call_time_pass_reference</i> to <i>On</i>.<br>";				
	}
	
	//check for safe mode
	if (ini_get ("safe_mode") != False){
		$InstallationsError = True;
		$Error .= "Disable in your php.ini <i>safe_mode</i>.<br>";				
	}			
	
	//check if all files and directories are readable
	FileIsReadable($Path."search.php");
	FileIsReadable($Path."admin.php");
	FileIsReadable($Path."spider.php");
	FileIsReadable($Path."Src/ADTools.inc.php");
	FileIsReadable($Path."Src/class.AdminConfig.inc.php");
	FileIsReadable($Path."Src/class.Config.inc.php");
	FileIsReadable($Path."Src/class.Const.inc.php");
	FileIsReadable($Path."Src/class.ExpressionPrepocessor.inc.php");
	FileIsReadable($Path."Src/class.FastTemplate.php");
	FileIsReadable($Path."Src/class.Log.inc.php");
	FileIsReadable($Path."Src/class.RevPolNotation.inc.php");
	FileIsReadable($Path."Src/class.SearchEngine.inc.php");
	FileIsReadable($Path."Src/class.SearchVisualizer.inc.php");
	FileIsReadable($Path."Src/class.Session.inc.php");
	FileIsReadable($Path."Src/class.SessionManager.inc.php");
	FileIsReadable($Path."Src/class.SpiderEngine.inc.php");
	FileIsReadable($Path."Src/class.SpiderState.inc.php");
	FileIsReadable($Path."Src/language.inc.php");
	FileIsReadable($Path."Src/limiter.inc.php");
	DirIsReadable($Path."log");
	DirIsReadable($Path."docs");
	DirIsReadable($Path."templates/standard");

	//send page to browser to put in all mysql-settings
	echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<form name="FormName" action="install.php" method="POST">
			<div align="center">
				<p><input type="hidden" value="3" name="Step"><b><font color="red">$Error</font></b><br>
					Please insert now your MySQL-settings:<br>
				</p>
				<table border="0" cellpadding="0" cellspacing="2">
					<tr>
						<td>MySQL-Host:</td>
						<td><input type="text" name="DBHost" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-Database:</td>
						<td><input type="text" name="DBName" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-User:</td>
						<td><input type="text" name="DBUser" size="24"></td>
					</tr>
					<tr>
						<td>MySQL-Passwort:</td>
						<td><input type="text" name="DBPassword" size="24"></td>
					</tr>
					<tr>
						<td colspan="2">
							<div align="center">
								<input type="submit" name="" value="Next"></div>
						</td>
					</tr>
				</table>
			</div>
		</form>
	</body>

</html>
AUSGABE;

exit();

}



/**********************************************************************
	3rd site
**********************************************************************/

// check mysql settings
if ($HTTP_POST_VARS["Step"]=="3"){
	
	//move global vars to local
	$DBHost		= $HTTP_POST_VARS["DBHost"];
	$DBUser		= $HTTP_POST_VARS["DBUser"];
	$DBPassword	= $HTTP_POST_VARS["DBPassword"];
	$DBName		= $HTTP_POST_VARS["DBName"];

	//check given user mysql settings
        @mysql_connect($DBHost,$DBUser,$DBPassword) or die ("<br>Your MySQL-datas are incorrect.<br>Please go back with your webbrowser and check your datas.<br><br>");
	if (	!mysql_select_db($DBName) OR
		$DBHost =="" OR
		$DBUser =="" OR
		$DBName ==""
		)
	{
		
		//failure output
		$InstallationsError = True;
		$Error .= "<br>Your MySQL-datas are incorrect.<br>
	        Please go back with your webbrowser and check your datas.<br><br>";
	        
	        $a = mysql_error();
	        if ( $a !="")
	        {
	        	$Error .= "MySQL said: <i>".mysql_error()."</i>";
		}
	        echo $Error;
	        exit();
	}

	//check mysqlversion
	$result = mysql_query ("SELECT VERSION() AS VERSION");
	$row = mysql_fetch_row($result);
	if ($row[0] < "3.23.32")
	{
		//wrong mysqlversion 
		$InstallationsError = True;
		$Error .= "Please upgrade your <i>MySQL-Version</i> for phpMySearch you must have MySQL 3.23.x or higher.<br>";	
		echo $Error;
		exit();	
	}
	else
	{

		//prepare DataBaseSettings
		$Text = <<<AUSGABE
<?php

\$DBHost     = "$DBHost";		//MySQL-Server
\$DBName     = "$DBName";		//MySQL-Database
\$DBUser     = "$DBUser";		//MySQL-Username
\$DBPassword = "$DBPassword";		//MySQL-Password


?>
AUSGABE;

		//create file for DataBaseSettings
		CreateNewEmptyFile($DataBaseSettings);

		//write DataBaseSettings into file
		$fp = fopen($DataBaseSettings,"w+");
		$fw = fwrite($fp,$Text);
		fclose ($fp);

		//create log- and tmp-files
		CreateNewEmptyFile($Path."log/spider.log");
		CreateNewEmptyFile($Path."log/search.log");
		CreateNewEmptyFile($Path."log/admin.log");
		CreateNewEmptyFile($Path."log/_header.txt");
		CreateNewEmptyFile($Path."log/php_homepage.txt");

		//outputs the last page if all is done successfully						
		echo <<<AUSGABE
<html>

	<head>
		<meta http-equiv="content-type" content="text/html;charset=iso-8859-1">
		<title>phpMySearch</title>
	</head>

	<body bgcolor="#ffffff">
		<div align="left">
			<p><b><font size="4">Congratulations!</font></b></p>
		</div>
		<p></p>
		<p>phpMySearch is successfully installed.</p>
		<p>Please read carefully now for all options the manual which is available here: <a href="manual/index.html" target="_blank">manual</a></p>
		<p></p>
		<p>In the manual you will inform about your standard login datas where you can login</p>
		<p>into your phpMySearch <a href="admin.php" target="_blank">admintool</a>.</p>
	</body>

</html>
AUSGABE;
	exit();
	}

}

/**********************************************************************
	end of installation
**********************************************************************/

?>